diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 3a49016bd..939f9752c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -4,266 +4,230 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.AABB;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 import org.slf4j.Logger;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRenderer<T extends Mob> extends EntityRenderer<T>
-{
-    private static final Logger LOGGER = LogUtils.getLogger();
-    public static final int MAX_ARMOR_LAYERS = 4;
-    protected ModelBase mainModel;
-    protected ModelBase armorModel;
-    protected ModelBase overlayModel;
-    protected String overlayTexture;
-    private final Minecraft mc;
+import java.util.ArrayList;
+import java.util.List;
 
-    public MobRenderer(ModelBase model, float shadowSize)
-    {
-        this.mainModel = model;
+public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
+    public static final float ENTITY_RENDER_SCALE = 16f;
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private final @NotNull List<@Nullable StaticEntityModel> setupModels = new ArrayList<>();
+    public MobRenderer(final float shadowSize) {
+        super();
         this.shadowSize = shadowSize;
-        this.mc = Minecraft.getMinecraft();
-    }
-
-
-    public void setArmorModel(ModelBase armor)
-    {
-        armorModel = armor;
-    }
-    public void setOverlayModel(ModelBase modelbase, String texture)
-    {
-        overlayModel = modelbase;
-        overlayTexture = texture;
     }
+    @Override
+    public void render(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        loadEntityTexture(entity);
+//        bindTexture("/assets/minecraft/textures/entity/creeper/debug.png");
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GL11.glDisable(GL11.GL_CULL_FACE);
 
-    public void render(Tessellator tessellator, T entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
         GL11.glPushMatrix();
-        GL11.glDisable(GL11.GL_CULL_FACE);
-        mainModel.swingProgress = getSwingProgress(entity, partialTick);
-        if (armorModel != null) armorModel.swingProgress = mainModel.swingProgress;
-        if (overlayModel != null) overlayModel.swingProgress = mainModel.swingProgress;
-        mainModel.isRiding = entity.isPassenger();
-        if (armorModel != null) armorModel.isRiding = mainModel.isRiding;
-        if (overlayModel != null) overlayModel.isRiding = mainModel.isRiding;
-        try
-        {
-            float bodyYaw = entity.yBodyRotO + (entity.yBodyRot - entity.yBodyRotO) * partialTick;
-            float headYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
-            float headPitch = entity.xRotO + (entity.xRot - entity.xRotO) * partialTick;
-            translateModel(entity, x, y, z);
-            float limbSway = limbSway(entity, partialTick);
-            setupRotations(entity, limbSway, bodyYaw, partialTick);
-            float scale = 0.0625F;
-            GL12.glEnable(GL12.GL_RESCALE_NORMAL);
-            GL11.glScalef(-1F, -1F, 1.0F);
-            setupScale(entity, partialTick);
-            GL11.glTranslatef(0.0F, -24F * scale - 0.0078125F, 0.0F);
-            float walkSpeed = entity.walkAnimSpeedO + (entity.walkAnimSpeed - entity.walkAnimSpeedO) * partialTick;
-            float walkProgress = entity.walkAnimPos - entity.walkAnimSpeed * (1.0F - partialTick);
-            if(walkSpeed > 1.0F)
-            {
-                walkSpeed = 1.0F;
-            }
-            loadEntityTexture(entity);
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
-            mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-            if (overlayModel != null)
-            {
-                bindTexture(overlayTexture);
-                overlayModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-            }
-            for(int renderPass = 0; renderPass < MAX_ARMOR_LAYERS; renderPass++)
-            {
-                if(prepareArmor(entity, renderPass, partialTick))
-                {
-                    armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    GL11.glDisable(GL11.GL_BLEND);
-                    GL11.glEnable(GL11.GL_ALPHA_TEST);
+        preRenderTransform(entity, x, y, z, yaw, partialTick);
+
+        float brightness = entity.getBrightness(partialTick);
+        if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
+
+        this.setupModels.clear();
+        final int maxRenderLayer = maxRenderLayer(entity);
+        for(int layer = 0; layer <= maxRenderLayer; layer++) {
+            try {
+                final StaticEntityModel model = getAndSetupModelForLayer(entity, brightness, partialTick, layer);
+                this.setupModels.add(model);
+                if (model != null) {
+                    model.render(tessellator);
                 }
+            } catch (final Exception e) {
+                LOGGER.error("Error setting up model on layer '{}' in renderer '{}'", layer, getClass().getSimpleName(), e);
             }
-
-            renderAdditional(entity, partialTick);
-            float brightness = entity.getBrightness(partialTick);
-            if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
-            int argb = getOverlayColor(entity, brightness, partialTick);
-            if((argb >> 24 & 0xff) > 0 || entity.hurtTime > 0 || entity.deathTime > 0)
-            {
-                GL11.glDisable(GL11.GL_TEXTURE_2D);
-                GL11.glDisable(GL11.GL_ALPHA_TEST);
-                GL11.glEnable(GL11.GL_BLEND);
-                GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-                GL11.glDepthFunc(514);
-                if(entity.hurtTime > 0 || entity.deathTime > 0)
-                {
-                    GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
-                    mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    if (overlayModel != null) overlayModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    for(int k = 0; k < MAX_ARMOR_LAYERS; k++)
-                    {
-                        if(prepareArmor(entity, k, partialTick))
-                        {
-                            GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
-                            armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                        }
+        }
+        renderAdditional(tessellator, entity, partialTick);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+
+        final int argb = getOverlayColor(entity, brightness, partialTick);
+        final boolean hasOverlayAlpha = Color.alphaFromInt(argb) > 0;
+        if(hasOverlayAlpha || entity.hurtTime > 0 || entity.deathTime > 0) {
+            GL11.glDisable(GL11.GL_TEXTURE_2D);
+            GL11.glDisable(GL11.GL_ALPHA_TEST);
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+            GL11.glDepthFunc(GL11.GL_EQUAL);
+            if(entity.hurtTime > 0 || entity.deathTime > 0) {
+                for(int layer = 0; layer <= maxRenderLayer; layer++) {
+                    final StaticEntityModel model = this.setupModels.get(layer);
+                    if (model != null) {
+                        GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
+                        model.render(tessellator);
                     }
-
                 }
-                if((argb >> 24 & 0xff) > 0)
-                {
-                    float r = (float)(argb >> 16 & 0xff) / 255F;
-                    float g = (float)(argb >> 8 & 0xff) / 255F;
-                    float b = (float)(argb & 0xff) / 255F;
-                    float a = (float)(argb >> 24 & 0xff) / 255F;
-                    GL11.glColor4f(r, g, b, a);
-                    mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    if (overlayModel != null) overlayModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    for(int l = 0; l < MAX_ARMOR_LAYERS; l++)
-                    {
-                        if(prepareArmor(entity, l, partialTick))
-                        {
-                            GL11.glColor4f(r, g, b, a);
-                            armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                        }
-                    }
 
+            }
+            if(hasOverlayAlpha) {
+                final float r = Color.redFromInt(argb)/255f;
+                final float g = Color.greenFromInt(argb)/255f;
+                final float b = Color.blueFromInt(argb)/255f;
+                final float a = Color.alphaFromInt(argb)/255f;
+                for(int layer = 0; layer < maxRenderLayer; layer++) {
+                    final StaticEntityModel model = this.setupModels.get(layer);
+                    if (model != null) {
+                        GL11.glColor4f(r, g, b, a);
+                        model.render(tessellator);
+                    }
                 }
-                GL11.glDepthFunc(GL11.GL_LEQUAL);
-                GL11.glDisable(GL11.GL_BLEND);
-                GL11.glEnable(GL11.GL_ALPHA_TEST);
-                GL11.glEnable(GL11.GL_TEXTURE_2D);
             }
-            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        }
-        catch(Exception exception)
-        {
-            LOGGER.error("Render exception in class '{}'!", getClass().getSimpleName(), exception);
+            GL11.glDepthFunc(GL11.GL_LEQUAL);
+            GL11.glDisable(GL11.GL_BLEND);
+            GL11.glEnable(GL11.GL_ALPHA_TEST);
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
-        GL11.glEnable(GL11.GL_CULL_FACE);
+
         GL11.glPopMatrix();
+
+        GL11.glEnable(GL11.GL_CULL_FACE);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         renderSpecials(tessellator, entity, x, y, z);
     }
 
-    protected void translateModel(T entity, double x, double y, double z)
-    {
-        GL11.glTranslatef((float)x, (float)y, (float)z);
-    }
+    protected void preRenderTransform(final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GL11.glTranslated(x, y, z);
+        GL11.glRotatef(-getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0, 1, 0);
+        GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
 
-    protected void setupRotations(T entity, float ticksExisted, float bodyYaw, float partialTick)
-    {
-        GL11.glRotatef(180F - bodyYaw, 0.0F, 1.0F, 0.0F);
-        if(entity.deathTime > 0)
-        {
-            float rotationProgress = ((((float)entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
+        if(entity.deathTime > 0) {
+            float rotationProgress = (((entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
             rotationProgress = MathHelper.sqrt_float(rotationProgress);
-            if(rotationProgress > 1.0F)
-            {
+            if(rotationProgress > 1.0F) {
                 rotationProgress = 1.0F;
             }
             GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
         }
     }
 
-    protected float getSwingProgress(T entity, float partialTick)
-    {
-        return entity.getSwingProgress(partialTick);
-    }
-
-    protected float limbSway(T entity, float partialTick)
-    {
-        return (float)entity.tickCount + partialTick;
+    protected float getLimbSwing(final @NotNull T entity, final float partialTick) {
+        return entity.walkAnimPos - entity.walkAnimSpeed * (1.0F - partialTick);
     }
 
-    protected void renderAdditional(T entity, float partialTick)
-    {
+    protected float getLimbYaw(final @NotNull T entity, final float partialTick) {
+        float limbYaw = MathHelper.lerp(entity.walkAnimSpeedO, entity.walkAnimSpeed, partialTick);
+        if(limbYaw > 1.0F) {
+            limbYaw = 1.0F;
+        }
+        return limbYaw;
     }
 
-    protected boolean prepareArmor(T entity, int layer, float partialTick)
-    {
-        return false;
+    protected float getLimbPitch(final @NotNull T entity, final float partialTick) {
+        return entity.tickCount + partialTick;
     }
 
-    protected float getMaxDeathRotation(T entity)
-    {
-        return 90F;
+    protected float getBodyYaw(final @NotNull T entity, final float partialTick) {
+        return MathHelper.lerp(entity.yBodyRotO, entity.yBodyRot, partialTick) * MathHelper.DEG_TO_RAD;
     }
 
-    protected int getOverlayColor(T entity, float brightness, float partialTick)
-    {
-        return 0;
+    protected float getHeadYaw(final @NotNull T entity, final float partialTick) {
+        return MathHelper.lerp(entity.yRotO, entity.yRot, partialTick) * MathHelper.DEG_TO_RAD;
     }
 
-    protected void setupScale(T entity, float partialTick)
-    {
+    protected float getHeadPitch(final @NotNull T entity, final float partialTick) {
+        return MathHelper.lerp(entity.xRotO, entity.xRot, partialTick) * MathHelper.DEG_TO_RAD;
     }
 
-    protected void renderSpecials(Tessellator tessellator, T entity, double x, double y, double z)
+    protected void renderSpecials(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z)
     {
-        if(mc.canRenderEntityLabel())
-        {
+        if(Minecraft.getMinecraft().canRenderEntityLabel()) {
             renderLivingLabel(tessellator, entity, Integer.toString(entity.id), x, y, z, 64, false);
         }
-        else if (!entity.nickname.isEmpty())
-        {
+        else if (!entity.nickname.isEmpty()) {
             renderLivingLabel(tessellator, entity, entity.getDisplayName(), x, y, z, 64, true);
         }
     }
 
-    protected void renderLivingLabel(Tessellator t, T entity, String s, double x, double y, double z, int maxDistance, boolean depthTest)
+    protected void renderLivingLabel(final @NotNull Tessellator t, final @NotNull T entity, final @NotNull CharSequence text, final double x, final double y, final double z, final int maxDistance, final boolean depthTest)
     {
-        final float f = (float) renderDispatcher.camera.distanceTo(entity);
-        if (f > maxDistance)
+        final float cameraDistance = (float) this.renderDispatcher.camera.distanceTo(entity);
+        if (cameraDistance > maxDistance)
         {
             return;
         }
         final FontRenderer sr = getFont();
-        final float f1 = 1.6F;
-        final float f2 = 0.01666667F * f1;
+        final float scale = 1.6f/60f;
+
         GL11.glPushMatrix();
-        GL11.glTranslatef((float) x + 0.0F, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
+        GL11.glTranslatef((float) x, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
         GL11.glNormal3f(0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
-        GL11.glScalef(-f2, -f2, f2);
-        GL11.glDisable(2896 /* GL_LIGHTING */);
+        GL11.glRotatef(-this.renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
+        GL11.glRotatef(this.renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
+        GL11.glScalef(-scale, -scale, scale);
+        GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glDepthMask(false);
-        if (!depthTest) GL11.glDisable(2929 /* GL_DEPTH_TEST */);
-        GL11.glEnable(3042 /* GL_BLEND */);
+        if (!depthTest) GL11.glDisable(GL11.GL_DEPTH_TEST);
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        byte byte0 = 0;
-        GL11.glDisable(3553 /* GL_TEXTURE_2D */);
+        GL11.glDisable(GL11.GL_TEXTURE_2D);
+
         t.startDrawingQuads();
-        final int j = sr.stringWidth(s) / 2;
+        final int halfTextWidth = sr.stringWidth(text) / 2;
         t.setColorRGBA_F(0.0F, 0.0F, 0.0F, 0.25F);
-        t.addVertex(-j - 1, -1 + byte0, 0.0D);
-        t.addVertex(-j - 1, 8 + byte0, 0.0D);
-        t.addVertex(j + 1, 8 + byte0, 0.0D);
-        t.addVertex(j + 1, -1 + byte0, 0.0D);
+        t.addVertex(-halfTextWidth - 1, -1, 0.0D);
+        t.addVertex(-halfTextWidth - 1,  8, 0.0D);
+        t.addVertex( halfTextWidth,      8, 0.0D);
+        t.addVertex( halfTextWidth,     -1, 0.0D);
         t.draw();
-        GL11.glEnable(3553 /* GL_TEXTURE_2D */);
-        sr.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0x20ffffff).call();
-        if (!depthTest) GL11.glEnable(2929 /* GL_DEPTH_TEST */);
+
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        sr.render(t, text, -halfTextWidth, 0).setColor(0x20ffffff).call();
+        if (!depthTest) GL11.glEnable(GL11.GL_DEPTH_TEST);
         GL11.glDepthMask(true);
-        sr.render(t, s, -sr.stringWidth(s) / 2, byte0).setColor(0xFFFFFF).call();
-        GL11.glEnable(2896 /* GL_LIGHTING */);
-        GL11.glDisable(3042 /* GL_BLEND */);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        sr.render(t, text, -halfTextWidth, 0).setColor(0xFFFFFF).call();
+        GL11.glEnable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_BLEND);
         GL11.glPopMatrix();
     }
-    public void loadEntityTexture(T entity)
+
+    protected int getOverlayColor(final @NotNull T entity, final float brightness, final float partialTick) {
+        return 0;
+    }
+
+    protected float getMaxDeathRotation(final @NotNull T entity)
     {
-        if (!Minecraft.getMinecraft().gameSettings.mobVariants.value)
-        {
+        return 90F;
+    }
+
+    protected int maxRenderLayer(final @NotNull T entity) {
+        return 0;
+    }
+
+    protected abstract @Nullable StaticEntityModel getAndSetupModelForLayer(final @NotNull T entity, float brightness, final float partialTick, final int layer);
+
+    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull T entity, final float partialTick)
+    {
+    }
+
+    public void loadEntityTexture(final @NotNull T entity)
+    {
+        if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) {
             bindTexture(entity.getDefaultEntityTexture());
         }
         else {
             bindTexture(entity.getEntityTexture());
         }
     }
+
+    @Override
+    public @NotNull AABB entityViewBox(@NotNull final T entity) {
+//        return this.entityModel.visibleBounds().cloneMove(entity.x, entity.y, entity.z);
+        return super.entityViewBox(entity);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
index b7a882126..6b9b0d62e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
@@ -1,53 +1,158 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.monster.MobZombieArmored;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererBiped<T extends Mob> extends MobRenderer<T>
-{
-	protected ModelBiped modelBipedMain;
-
-
-	public MobRendererBiped(ModelBiped model, float shadowSize)
-    {
-        super(model, shadowSize);
-
-        this.modelBipedMain = model;
-	}
-
-	@Override
-	protected void renderAdditional(T entity, float partialTick) {
-		if (entity instanceof IItemHolding) {
-			IItemHolding itemHolder = (IItemHolding) entity;
-			ItemStack itemstack = itemHolder.getHeldItem();
-			if(itemstack != null) {
-				GL11.glPushMatrix();
-				if (((IItemHolding) entity).isLeftHanded()) {
-					modelBipedMain.armLeft.translateTo(0.0625F);
-					GL11.glRotatef(-90, 1, 0, 0);
-					GL11.glRotatef(180, 0, 1, 0);
-					GL11.glScalef(-1, 1, 1);
-					GL11.glTranslatef(1/16f, 2/16f, -10f/16f);
-					ItemModelDispatcher.getInstance().getDispatch(itemstack)
-						.render(Tessellator.instance, entity, itemstack, DisplayPos.THIRD_PERSON_LEFT_HAND, true, 1, entity.getBrightness(partialTick), 1f, partialTick, true);
-				} else {
-					modelBipedMain.armRight.translateTo(0.0625F);
-					GL11.glRotatef(-90, 1, 0, 0);
-					GL11.glScalef(-1, 1, -1);
-					GL11.glTranslatef(1/16f, 2/16f, -10f/16f);
-					ItemModelDispatcher.getInstance().getDispatch(itemstack)
-						.render(Tessellator.instance, entity, itemstack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, entity.getBrightness(partialTick), 1f, partialTick, false);
-				}
-				GL11.glPopMatrix();
-			}
-		}
-	}
+public abstract class MobRendererBiped<T extends Mob> extends MobRenderer<T> {
+
+    public MobRendererBiped(final float shadowSize) {
+        super(shadowSize);
+    }
+
+    protected abstract @Nullable StaticEntityModel getActiveModel(@NotNull final T entity);
+
+    @Override
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final T entity, final float brightness, final float partialTick, final int layer) {
+       return setupAnimations(entity, getActiveModel(entity), partialTick, layer);
+    }
+
+    protected @Nullable StaticEntityModel setupAnimations(@NotNull final T entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
+        if (model == null) return null;
+        model.resetBones();
+        final BoneTransform rightArm = model.getTransform("rightArm");
+        final BoneTransform leftArm = model.getTransform("leftArm");
+        final BoneTransform rightLeg = model.getTransform("rightLeg");
+        final BoneTransform leftLeg = model.getTransform("leftLeg");
+        final BoneTransform waist = model.getTransform("waist");
+        final BoneTransform head = model.getTransform("head");
+
+        final float bodyYaw = getBodyYaw(entity, partialTick);
+        final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(entity, partialTick);
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+        final float limbPitch = getLimbPitch(entity, partialTick);
+        final float swingProgress = entity.getSwingProgress(partialTick);
+
+        head.rotX = headPitch;
+        head.rotY = headYaw;
+        if (entity.getHeldObject() != null) {
+            final double rotX = Math.cos(limbSwing / 2 * 0.6662F) * 2.0F * limbYaw * 0.125F - 0.65f;
+            rightArm.rotX = rotX;
+            leftArm.rotX = rotX;
+        } else {
+            rightArm.rotX = Math.cos(limbSwing * 0.6662F + Math.PI) * 2.0F * limbYaw * 0.5F;
+            leftArm.rotX = Math.cos(limbSwing * 0.6662F) * 2.0F * limbYaw * 0.5F;
+        }
+        rightLeg.rotX = Math.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leftLeg.rotX = Math.cos(limbSwing * 0.6662F + Math.PI) * 1.4F * limbYaw;
+        if(entity.vehicle != null)
+        {
+            rightArm.rotX += -36 * MathHelper.DEG_TO_RAD;
+            leftArm.rotX += -36 * MathHelper.DEG_TO_RAD;
+            rightLeg.rotX = -72 * MathHelper.DEG_TO_RAD;
+            leftLeg.rotX = -72 * MathHelper.DEG_TO_RAD;
+            rightLeg.rotY = 18 * MathHelper.DEG_TO_RAD;
+            leftLeg.rotY = -18 * MathHelper.DEG_TO_RAD;
+        }
+        if (entity instanceof IItemHolding) {
+            final boolean hasItem = ((IItemHolding) entity).getHeldItem() != null;
+            if (hasItem) {
+                if (((IItemHolding) entity).isLeftHanded()) {
+                    leftArm.rotX = (leftArm.rotX * 0.5F) - 18 * MathHelper.DEG_TO_RAD;
+                } else {
+                    rightArm.rotX = (rightArm.rotX * 0.5F) - 18 * MathHelper.DEG_TO_RAD;
+                }
+            }
+
+        }
+        if (entity instanceof IItemHolding && ((IItemHolding) entity).isLeftHanded()) {
+            waist.rotY = Math.sin(Math.sqrt(swingProgress) * Math.PI * -2.0F) * 0.2F;
+
+            float f6 = 1.0F - swingProgress;
+            f6 *= f6;
+            f6 *= f6;
+            f6 = 1.0F - f6;
+            final double f7 = Math.sin(f6 * Math.PI);
+            final double f8 = Math.sin(swingProgress * Math.PI) * -(Math.toRadians(head.rotX) - 0.7F) * 0.75F;
+
+            leftArm.rotX -= f7 * 1.2D + f8;
+            leftArm.rotY += waist.rotY * 2.0F;
+            leftArm.rotZ = Math.sin(swingProgress * Math.PI) * 0.4F;
+        } else {
+            waist.rotY = Math.sin(Math.sqrt(swingProgress) * Math.PI * 2.0F) * 0.2F;
+
+            float f6 = 1.0F - swingProgress;
+            f6 *= f6;
+            f6 *= f6;
+            f6 = 1.0F - f6;
+            final double f7 = Math.sin(f6 * Math.PI);
+            final double f8 = Math.sin(swingProgress * Math.PI) * -(Math.toRadians(head.rotX) - 0.7F) * 0.75F;
+
+            rightArm.rotX -= f7 * 1.2D + f8;
+            rightArm.rotY += waist.rotY * 2.0F;
+            rightArm.rotZ = Math.sin(swingProgress * Math.PI) * -0.4F;
+        }
+
+        if(entity.isSneaking())
+        {
+            waist.rotX = 0.5F;
+            leftLeg.rotX -= 0.5F;
+            rightLeg.rotX -= 0.5F;
+            head.rotX -= 0.5F;
+
+            rightArm.rotX -= 0.4F;
+            leftArm.rotX -= 0.4F;
+            if (entity.getHeldObject() != null) {
+                rightArm.rotX -= 0.4f;
+                leftArm.rotX -= 0.4f;
+            }
+        }
+        rightArm.rotZ += Math.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        leftArm.rotZ -= Math.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        rightArm.rotX += Math.sin(limbPitch * 0.067F) * 0.05F;
+        leftArm.rotX -= Math.sin(limbPitch * 0.067F) * 0.05F;
+
+        return model;
+    }
+
+    @Override
+    protected void renderAdditional(@NotNull final Tessellator tessellator, final @NotNull T entity, final float partialTick) {
+        if (entity instanceof IItemHolding) {
+            final IItemHolding itemHolder = (IItemHolding) entity;
+            final ItemStack itemstack = itemHolder.getHeldItem();
+
+            final StaticEntityModel model = getActiveModel(entity);
+
+            if(itemstack != null) {
+                GL11.glPushMatrix();
+                if (((IItemHolding) entity).isLeftHanded()) {
+                    if (model != null) model.translateToBone("leftItem");
+                    GL11.glScalef(-1, 1, -1);
+                    GL11.glScalef(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
+                    ItemModelDispatcher.getInstance().getDispatch(itemstack)
+                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_LEFT_HAND, true, 1, LightmapHelper.isLightmapEnabled() ? 1f : entity.getBrightness(partialTick), 1f, partialTick, true);
+                } else {
+
+                    if (model != null) model.translateToBone("rightItem");
+                    GL11.glScalef(-1, 1, 1);
+                    GL11.glScalef(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
+                    ItemModelDispatcher.getInstance().getDispatch(itemstack)
+                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, LightmapHelper.isLightmapEnabled() ? 1f : entity.getBrightness(partialTick), 1f, partialTick, false);
+                }
+                GL11.glPopMatrix();
+            }
+        }
+    }
 }
